#! /usr/bin/env python

############################################################################
# amaroK Intro-Play 0.5
# (c) 2005 Bernhard Kausler <bernhardkausler@compuserve.de>
#
# Depends on: Python 2.3.4 (lower versions not tested)
############################################################################
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
############################################################################


from sys import stdin
from os import system
from os import popen
from threading import Timer

class IntroPlayer:
    def __init__(self):
        self.seconds = 20
        self.t = 0

    def start(self):
        while True:
            line = stdin.readline()
            line = line.strip("\n")
            line = '"' + line + '"'
                                     
            if line.find("engineStateChange: playing") > 0:
                if self.t != 0:
                    self.t.cancel()
                self.t = Timer(self.seconds, system, ["dcop amarok player next"])
                self.t.start()
    
            elif line.find("trackChange") > 0:
                pass

            elif line.find("configure") > 0:
                while True:
                    f = popen('kdialog --inputbox "Seconds to be played:" 20')
                    ip = f.readline()

                    try:
                        self.seconds = int(ip)
                        if self.seconds < 0:
                            self.seconds = 20
                            continue
                    except:
                        continue

                    break
          
            else:
                if self.t != 0:
                    self.t.cancel()
                
ip = IntroPlayer()
ip.start()
